%define upstream_version 2.1-14
%global debug_package %{nil}

Summary:   Intel / AMD CPU Microcode Utility
Name:      microcode_ctl
Version:   2.1
Release:   %mkrel 10
Group:     System/Kernel and hardware
License:   GPLv2
Url:       https://pagure.io/microcode_ctl
Source0:   https://releases.pagure.org/microcode_ctl/%{name}-%{upstream_version}.tar.xz
# Intel firmware downloader (Debian)
Source2:   update-intel-microcode
Source3:   update-intel-microcode.8
# AMDl firmware downloader
Source4:   update-amd-microcode
Source5:   update-amd-microcode.8
# needed by firmware downloaders
Recommends:  curl
# we have microcode packaged
Recommends:  microcode
Requires(post): rpm-helper
Requires(preun): rpm-helper
ExclusiveArch: %ix86 x86_64

%description
Since PentiumPro, Intel CPU are made of a RISC chip and of a microcode whose
purpose is to decompose "old" ia32 instruction into new risc ones.
P6 familly is concerned: PPro, PII, Celeron, PIII, Celeron2, Core 2, ...
Recent kernels have the ability to update this microcode.

The microcode update is volatile and needs to be uploaded on each system
boot. I.e. it doesn't reflash your cpu permanently.
Reboot and it reverts back to the old microcode.

This package also support updating latest AMD CPU microcode.

%prep
%setup -q -n %{name}-%{upstream_version}

%build
make CFLAGS="$RPM_OPT_FLAGS"

%install
mkdir -p %{buildroot}%{_mandir}/man8
mkdir -p %{buildroot}%{_sbindir}
%make_install INSDIR=%{_sbindir} PREFIX=/usr
# do not ship non-free firmware in this package
rm -rf %buildroot/lib/firmware
# install intel firmware downloader 
install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_sbindir}
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_mandir}/man8
# install AMD firmware downloader 
install -m 755 %{SOURCE4} $RPM_BUILD_ROOT%{_sbindir}
install -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_mandir}/man8
#
mkdir -p $RPM_BUILD_ROOT/lib/firmware/amd-ucode 
mkdir -p $RPM_BUILD_ROOT/lib/firmware/intel-microcode

%files
%doc README
%_sbindir/*
%_mandir/man8/*
/lib/firmware/amd-ucode
/lib/firmware/intel-microcode

%preun
%_preun_service %{name}


%changelog
* Thu Feb 13 2020 umeabot <umeabot> 2.1-10.mga8
+ Revision: 1515153
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%makeinstall_std

* Sun Sep 23 2018 umeabot <umeabot> 2.1-9.mga7
+ Revision: 1299533
- Mageia 7 Mass Rebuild

* Thu Jan 04 2018 ovitters <ovitters> 2.1-8.mga7
+ Revision: 1190256
- Update to upstream 2.1-14. 20171117
- fix url

* Fri Jun 16 2017 zezinho <zezinho> 2.1-7.mga6
+ Revision: 1107798
- remove cron for intel download as upstream rss was removed

* Mon Feb 29 2016 zezinho <zezinho> 2.1-6.mga6
+ Revision: 980847
- remove service calls (mga#17832)

* Mon Feb 08 2016 umeabot <umeabot> 2.1-5.mga6
+ Revision: 947976
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 2.1-4.mga5
+ Revision: 744380
- Second Mageia 5 Mass Rebuild

* Mon Sep 15 2014 tv <tv> 2.1-3.mga5
+ Revision: 676039
- s/uggests:/Recommends:/
- drop the service as microcode is now autoloaded

* Fri Dec 20 2013 tv <tv> 2.1-3.mga4
+ Revision: 559058
- fix loading microcode: just load kernel module + fix path (mga#11934)

* Mon Oct 21 2013 umeabot <umeabot> 2.1-2.mga4
+ Revision: 540556
- Mageia 4 Mass Rebuild
+ tv <tv>
- fix AMD URL

* Wed Oct 09 2013 tv <tv> 2.1-1.mga4
+ Revision: 493879
- new release
- new URL

* Sat Jan 12 2013 umeabot <umeabot> 1.17-15.mga3
+ Revision: 360024
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Tue Jun 19 2012 zezinho <zezinho> 1.17-14.mga3
+ Revision: 261992
- cleanup spec
+ alien <alien>
- Fix wrong exit-code on newer kernels #4327 & #6175
+ tv <tv>
- make it clear latest Intel CPUs are supported

* Sat Jan 15 2011 tmb <tmb> 1.17-13.mga1
+ Revision: 19865
- suggest microcode
- imported package microcode_ctl


* Sat Jan 15 2011 Thomas Backlund <tmb@mageia.org> 1.17-13.mga1
- initial Mageia import
- update S1-S3, P0: intel microcode is now under /lib/firmware too

* Mon Dec 06 2010 Oden Eriksson <oeriksson@mandriva.com> 1.17-12mdv2011.0
+ Revision: 612866
- the mass rebuild of 2010.1 packages

* Fri Feb 05 2010 Thomas Backlund <tmb@mandriva.org> 1.17-11mdv2010.1
+ Revision: 501008
- add missing fi in microcode_ctl initscript (#57421)

* Thu Feb 04 2010 Frederic Crozat <fcrozat@mandriva.com> 1.17-10mdv2010.1
+ Revision: 500855
- Fix update-intel-microcode in download-only mode

* Thu Feb 04 2010 Frederic Crozat <fcrozat@mandriva.com> 1.17-9mdv2010.1
+ Revision: 500844
- improve description
- improve scripts to support --download-only option
- do not try to load amd microcode for kernel < 2.6.29

* Wed Feb 03 2010 Frederic Crozat <fcrozat@mandriva.com> 1.17-8mdv2010.1
+ Revision: 500138
- Remove non-free microcode from Intel
- Add support for AMD microcode (Fedora)
- Add script from debian to download Intel microcode
- Create script to download AMD microcode
- add monthly cron to update microcode, if needed

* Mon Sep 14 2009 Thierry Vignaud <tv@mandriva.org> 1.17-7mdv2010.0
+ Revision: 439801
- rebuild

* Mon Jan 19 2009 Thierry Vignaud <tv@mandriva.org> 1.17-6mdv2009.1
+ Revision: 331275
- Updated microcodes are avaible on http://downloadcenter.intel.com/default.aspx

* Tue Jul 29 2008 Thierry Vignaud <tv@mandriva.org> 1.17-5mdv2009.0
+ Revision: 252418
- rebuild

* Wed Mar 12 2008 Götz Waschk <waschk@mandriva.org> 1.17-3mdv2008.1
+ Revision: 187077
- build on x86_64 as well (bug #38821)
- fix buildrequires

* Wed Mar 12 2008 Götz Waschk <waschk@mandriva.org> 1.17-2mdv2008.1
+ Revision: 187056
- update to the latest microcode release from intel

* Fri Dec 21 2007 Olivier Blin <oblin@mandriva.com> 1.17-1mdv2008.1
+ Revision: 136579
- restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Fri Jun 29 2007 Götz Waschk <waschk@mandriva.org> 1.17-1mdv2008.0
+ Revision: 45858
- new version

  + Thierry Vignaud <tv@mandriva.org>
    - Import microcode_ctl



* Fri Jun 30 2006 Götz Waschk <waschk@mandriva.org> 1.14-1mdk
- New release 1.14

* Thu Mar 02 2006 Götz Waschk <waschk@mandriva.org> 1.13-1mdk
- New release 1.13

* Mon Jan  9 2006 Olivier Blin <oblin@mandriva.com> 1.12-4mdk
- convert parallel init to LSB

* Sat Dec 31 2005 Götz Waschk <waschk@mandriva.org> 1.12-3mdk
- fix error on preun

* Sat Dec 31 2005 Götz Waschk <waschk@mandriva.org> 1.12-2mdk
- first try of parallel init

* Tue Sep 13 2005 Götz Waschk <waschk@mandriva.org> 1.12-1mdk
- new version

* Thu Aug 11 2005 Thierry Vignaud <tvignaud@mandriva.com> 1.11-3mdk
- drop devfs support
- drop udev rule, udev is already aware of it

* Thu Nov 18 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.11-2mdk
- source 1: fix init script (Eric Pielbug, #12286)

* Wed Nov 03 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.11-1mdk
- new release

* Tue Oct 26 2004 Goetz Waschk <waschk@linux-mandrake.com> 1.10-1mdk
- New release 1.10

* Fri Sep 10 2004 Goetz Waschk <waschk@linux-mandrake.com> 1.09-1mdk
- New release 1.09

* Mon Sep  6 2004 Götz Waschk <waschk@linux-mandrake.com> 1.08-2mdk
- add udev support, fixes bug #11204

* Thu Aug 12 2004 Goetz Waschk <waschk@linux-mandrake.com> 1.08-1mdk
- New release 1.08

* Tue Jun 08 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.06-10mdk
- fix typo in description (Eskild Hustvedt)

* Tue Jun 08 2004 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.06-9mdk
- fix microcode update on 2.6.x with devfs (anthill #897)

* Thu Oct  9 2003 Götz Waschk <waschk@linux-mandrake.com> 1.06-8mdk
- spec fixes
- it's x86-only

* Fri Apr 25 2003 Götz Waschk <waschk@linux-mandrake.com> 1.06-7mdk
- fix buildrequires (thanks to the bot from Stefan van der Eijk)

* Tue Mar 11 2003 Götz Waschk <waschk@linux-mandrake.com> 1.06-6mdk
- fix build

* Fri Mar 22 2002 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.06-5mdk
- more macros use
- simplify %%preun

* Mon Feb 25 2002 Götz Waschk <waschk@linux-mandrake.com> 1.06-4mdk
- fix init script, thanks to DUCLOS Andre <shirka@wanadoo.fr>

* Mon Feb 18 2002 Götz Waschk <waschk@linux-mandrake.com> 1.06-3mdk
- update init script, load microcode module for devfs users

* Fri Oct 12 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.06-2mdk
- happy birthday, mister rpmlint

* Tue Aug 21 2001 Lenny Cartier <lenny@mandrakesoft.com> 1.06-1mdk
- updated to 1.06

* Thu Mar 22 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.04-1mdk
- new version

* Wed Feb 28 2001 Thierry Vignaud <tvignaud@mandrakesoft.com> 1.03-1mdk
- Initial RPM
